class ColumnVector
{
public:
	ColumnVector(int _n);
	void CreatColumn(int _n);
	double *Element;
	void Transpose();
	ColumnVector operator =(ColumnVector &tmp);
	int n;
private:
	
};

ColumnVector::ColumnVector(int _n)
{
	Element=new double [_n];
	n=_n;	
}
void ColumnVector::CreatColumn(int _n)
{
	Element=new double [_n];
	n=_n;	
}
void ColumnVector::Transpose()
{
	ColumnVector tmp(n);
	for (int i=0;i<n;i++)
	{
		tmp.Element[n-i-1]=Element[i];
	}
	for (i=0;i<n;i++)
	{
		Element[i]=tmp.Element[i];
	}
}
ColumnVector ColumnVector::operator =(ColumnVector &tmp)
{
	n=tmp.n;
	this->CreatColumn(n);
	
	for (int i=0;i<n;i++)
	{
		Element[i]=tmp.Element[i];
	}
	return tmp;
}

class Matrix
{
public:
	Matrix(){}
	Matrix(int _row,int _column);
	bool GaussElimination(ColumnVector B,int n,int count);
	void GaussElimination2(ColumnVector B,int n,int count);
	void SetSize(int _row,int _column);
	void CreatMatrix(int _row,int _column);
	void Transpose();
	void printOut();
	void printOut(ColumnVector B);

	double **Element;
protected:
	
private:
	int row;		//number of row
	int column;		//number of column
};

Matrix::Matrix(int _row,int _column)
{
	row=_row;
	column=_column;

	Element=new double*[row];
	for (int i=0;i<row;i++)
	{
		Element[i]=new double[column];
	}
}
void Matrix::CreatMatrix(int _row,int _column)
{
	row=_row;
	column=_column;

	Element=new double*[row];
	for (int i=0;i<row;i++)
	{
		Element[i]=new double[column];
	}
}
bool Matrix::GaussElimination(ColumnVector B,int n,int count=0)
{
	if (count==n-1)
	{
		double tmp=Element[count][count];
		if (tmp==0)
		{
			return false;
		}
		else
		{
			B.Element[count]=B.Element[count]/tmp;
			Element[n-1][n-1]=1;
			return true;
		}
	}
	else
	{
		bool isSingular=false;
		//ith row ù° ڸ 1 
		double tmp=Element[count][count];
		if (tmp==0)
		{
			return false;
		}
		else
		{
			for (int j=count;j<n;j++)
			{
				Element[count][j]=Element[count][j]/tmp;
			}
			B.Element[count]=B.Element[count]/tmp;

			for (int i=count+1;i<n;i++)
			{
				double ratio=Element[i][count];
				for (int j=count;j<n;j++)
				{
					Element[i][j]-=ratio*Element[count][j];
				}
				B.Element[i]-=ratio*B.Element[count];
			}
			return GaussElimination(B,n,count+1);
		}
	}
}
void Matrix::Transpose()
{
	Matrix tmp(column,row);
	for (int i=0;i<row;i++)
	{
		for (int j=0;j<column;j++)
		{
			tmp.Element[j][i]=Element[i][j];
		}
	}
	for (i=0;i<row;i++)
	{
		for (int j=0;j<column;j++)
		{
			Element[i][j]=tmp.Element[i][j];
		}
	}		
}
void Matrix::GaussElimination2(ColumnVector B,int n,int count=0)
{
	int tmp=row-1;
	for (int j=tmp;j>=1;j--)
	{
		for (int i=tmp-1;i>=0;i--)
		{	
			double tmp2=Element[i][j]/Element[tmp][j];
			Element[i][j]=0;
			B.Element[i]=B.Element[i]-B.Element[tmp]*tmp2;
		}
		tmp--;
	}
}
void Matrix::printOut()
{
	for (int i=0;i<row;i++)
	{
		for (int j=0;j<column;j++)
		{
			cout<<this->Element[i][j]<<"\t";
		}
		cout<<endl;
	}
}
void Matrix::printOut(ColumnVector B)
{
	for (int i=0;i<row;i++)
	{
		for (int j=0;j<column;j++)
		{
			cout<<this->Element[i][j]<<"\t";
		}
		cout<<B.Element[i];
		cout<<endl;
	}
}