#include <stdio.h>

double cox_deboor_recursion(int i, int k, double u, double* knot);

void main()
{
	int i;
	int ncp = 6;
	double *knot = new double[ncp+4];
	double *d_x = new double[ncp];
	double *d_y = new double[ncp];
	double *d_z = new double[ncp];
	double r_x = 0;
	double r_y = 0;
	double r_z = 0;
	double u = 1.5;

	d_x[0] = 0;	d_y[0] = 0; d_z[0] = 0;
	d_x[1] = 0;	d_y[1] = 2; d_z[1] = 0;
	d_x[2] = 2;	d_y[2] = 2; d_z[2] = 0;
	d_x[3] = 2;	d_y[3] = 0; d_z[3] = 0;
	d_x[4] = 4;	d_y[4] = 0; d_z[4] = 0;
	d_x[5] = 4;	d_y[5] = 2; d_z[5] = 0;

	knot[0] = knot[1] = knot[2] = knot[3] = 0;
	knot[4] = 1;
	knot[5] = 2;
	knot[6] = knot[7] = knot[8] = knot[9] = 4;

	printf("[Given]\n\n");
	for(i = 0; i < ncp; i++)
	{
		printf("d[%d] = (%lf, %lf, %lf)\n",i, d_x[i], d_y[i], d_z[i]);
	}
	printf("\n");

	for(i = 0; i < ncp + 4; i++)
	{
		printf("u[%d] = %lf\n",i, knot[i]);
	}
	printf("\n");
	
	printf("u* = %lf\n\n\n", u);

	for(i = 0 ; i < ncp ; i++) // i:basis function index
	{					
		double N = cox_deboor_recursion(i, 4, u, knot);
		r_x += d_x[i] * N;
		r_y += d_y[i] * N;
		r_z += d_z[i] * N;
	}	

	printf("[Solution]\n\n");
	printf("r(u*) = r(%lf) = (%lf, %lf, %lf)\n\n",u, r_x, r_y, r_z);
}

double cox_deboor_recursion(int i, int k, double u, double* knot)
{
	double N_1, N_2, r_1, r_2, coordinate;

	if(k==1)
	{
		if( knot[i]<= u && u < knot[i+1] ) coordinate = 1;			
		else coordinate =0 ;
	}	
	else
	{
		N_1 = cox_deboor_recursion( i, k-1, u, knot);
		N_2 = cox_deboor_recursion( i+1, k-1, u, knot);

		if ( (knot[i+k-1]-knot[i]) == 0 ) r_1 = 0;
		else r_1 = (u-knot[i])/(knot[i+k-1]-knot[i]);
		if ((knot[i+k]-knot[i+1]) == 0) r_2 = 0 ;
		else r_2 = (knot[i+k]-u)/(knot[i+k]-knot[i+1]);

		coordinate = r_1*N_1 + r_2*N_2;
	}
	return coordinate;  
}
